# ----------------------------------------------------------------------
# LALSuite: container build
#
# Build and deploy the LALSuite containers
# ----------------------------------------------------------------------

# snippets to simplify job creation
.container_snippets:
  nightly_image:
    - IMAGE_TAG="nightly-${CI_JOB_NAME##*:}"
  tag_image:
    - IMAGE_TAG="${CI_COMMIT_TAG##*v}-${CI_JOB_NAME##*:}"
  rhel:
    - set -x
    # add RPMs to directory to pass to docker
    - mkdir rpms && mv rpmbuild/RPMS/*/*.rpm rpms
    - rm -rf rpmbuild*
  debian:
    - set -x
    # add deb packages to directory to pass to docker
    - mkdir debs && mv *.deb debs
    - rm *.changes *.dsc *.orig.*

#
# Build container images that include the latest build outputs
#

# job template for docker builds
.docker:
  image: docker:latest
  variables:
    DOCKER_DRIVER: overlay
    IMAGE_NAME: "${CI_REGISTRY_IMAGE}"
  stage: docker
  script:
    # build container and push to registry
    - docker build --pull -t ${IMAGE_NAME}:${IMAGE_TAG} --file ${DOCKER_FILE} .
    - |
      if [ "X${EXECUTE_DEPLOY_ACTIONS}" != "Xyes" ]; then
        echo "Skipping rest of job as EXECUTE_DEPLOY_ACTIONS!=yes"
        exit 100
      fi
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker push ${IMAGE_NAME}:${IMAGE_TAG}
  allow_failure:
    exit_codes: 100   # EXECUTE_DEPLOY_ACTIONS!=yes

.docker:nightly:
  extends:
    - .docker
  rules:
    - !reference [.ci-docker, rules]
    - !reference [.ci-nightly-deploy, rules]

.docker:tags:
  extends:
    - .docker
  rules:
    - !reference [.ci-lalsuite-tag-build, rules]

# template for RHEL docker builds
.docker:el:
  extends:
    - .docker

.docker:el7:
  variables:
    DOCKER_FILE: ".gitlab-ci-el7.Dockerfile"
  extends:
    - .docker:el
  needs:
    - lal:rpm-el7
    - lalframe:rpm-el7
    - lalmetaio:rpm-el7
    - lalsimulation:rpm-el7
    - lalburst:rpm-el7
    - lalinspiral:rpm-el7
    - lalinference:rpm-el7
    - lalpulsar:rpm-el7
    - lalapps:rpm-el7

.docker:el8:
  variables:
    DOCKER_FILE: ".gitlab-ci-el8.Dockerfile"
  extends:
    - .docker:el
  needs:
    - lal:rpm-el8
    - lalframe:rpm-el8
    - lalmetaio:rpm-el8
    - lalsimulation:rpm-el8
    - lalburst:rpm-el8
    - lalinspiral:rpm-el8
    - lalinference:rpm-el8
    - lalpulsar:rpm-el8
    - lalapps:rpm-el8

# template for Debian docker builds
.docker:debian:
  extends:
    - .docker
  variables:
    DOCKER_FILE: ".gitlab-ci-bullseye.Dockerfile"
  needs:
    - lal:deb
    - lalframe:deb
    - lalmetaio:deb
    - lalsimulation:deb
    - lalburst:deb
    - lalinspiral:deb
    - lalinference:deb
    - lalpulsar:deb
    - lalapps:deb

# template for Koji docker builds
.docker:koji:
  extends:
    - .docker
  variables:
    DOCKER_FILE: ".gitlab-ci-koji.Dockerfile"
  needs:
    - lal:koji
    - lalframe:koji
    - lalmetaio:koji
    - lalsimulation:koji
    - lalburst:koji
    - lalinspiral:koji
    - lalpulsar:koji
    - lalinference:koji
    - lalapps:koji
  rules:
    - !reference [.ci-koji, rules]
    - !reference [.ci-nightly-deploy, rules]

# build nightly containers from the RPMs
docker:nightly:el7:
  before_script:
    - !reference [.container_snippets, nightly_image]
    - !reference [.container_snippets, rhel]
  extends:
    - .docker:el7
    - .docker:nightly

docker:nightly:el8:
  before_script:
    - !reference [.container_snippets, nightly_image]
    - !reference [.container_snippets, rhel]
  extends:
    - .docker:el8
    - .docker:nightly

# build tagged containers from the rpms
docker:tags:el7:
  before_script:
    - !reference [.container_snippets, tag_image]
    - !reference [.container_snippets, rhel]
  extends:
    - .docker:el7
    - .docker:tags

docker:tags:el8:
  before_script:
    - !reference [.container_snippets, tag_image]
    - !reference [.container_snippets, rhel]
  extends:
    - .docker:el8
    - .docker:tags

# build a nightly container for Debian bullseye
docker:nightly:bullseye:
  before_script:
    - !reference [.container_snippets, nightly_image]
    - !reference [.container_snippets, debian]
  extends:
    - .docker:debian
    - .docker:nightly

# build a tagged container for Debian bullseye
docker:tags:bullseye:
  before_script:
    - !reference [.container_snippets, tag_image]
    - !reference [.container_snippets, debian]
  extends:
    - .docker:debian
    - .docker:tags

# build a nightly containers from the koji rpms
docker:nightly:el7-koji:
  before_script:
    - !reference [.container_snippets, nightly_image]
    - !reference [.container_snippets, rhel]
  extends:
    - .docker:koji
    - .docker:nightly
